<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<NuxtLayout name="default">
		<div>
			<!-- sidebar navigation teleported to template -->
			<SidebarNav :nav="navItems" :title="'Catalog'" />
			<TopbarTopBar :breadcrumb="breadcrumb" />
			<div class="detail-header">
				<div class="row">
					<div class="col-xl-12">
						<div class="title">
							<h2>{{ columnDetails?.name }}</h2>
							<span class="type-yellow">Columns</span>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-body">
				<div class="row">
					<div class="col-xl-3">
						<div class="about">
							<InfoBox title="Creation date" :text="formatDate(columnDetails?.createdAt)" />
							<InfoBox title="Last Edition" :text="formatDate(columnDetails?.updatedAt)" />
						</div>
						<div class="info user">
							<h3>Owner</h3>
							<UserProfile />
						</div>
						<div class="info user">
							<h3>Shared with</h3>
							<UsersSelectionList />
						</div>
					</div>
					<div class="col-xl-8 offset-xl-1">
						<div class="about details">
							<InfoBox title="Domains" text="-" />
							<InfoBox title="Data type" :text="columnDetails?.metadata?.dataType" />
							<!-- <InfoBox title="Platform" text="AWS S3" /> -->
							<InfoBox title="Quality" text="" />
						</div>
						<div class="row">
							<div class="col-xl-9">
								<EditableTextBox title="Full description"
									:text="columnDetails?.description ? columnDetails?.description : '-'" />
								<EditableTextBox title="Short description"
									:text="columnDetails?.summary ? columnDetails?.summary : '-'" />
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-tab">
				<ColumnsTabs :quality="columnDetails?.qualityMeasurements" />
			</div>
			<div class="container">
				<div class="offset-xl-1 col-xl-10 mt-160">
					<BannersBannerCta :banners="BannerCta" />
				</div>
			</div>
		</div>
	</NuxtLayout>
</template>
<script setup lang="ts">
import ArtifactDetailTabs from '~/components/tabs/ArtifactDetailTabs.vue';
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';
import { useRoute } from 'vue-router';
import { formatDate, removeHtmlTags } from '~/utils/utils';
import ColumnsTabs from '../../../../components/tabs/ColumnsTabs.vue';

const route = useRoute();

const columnDetails = ref<any>(null);

// Define Breadcrumb interface
interface BreadcrumbI {
    title: string;
    link: string;
}

const breadcrumb = ref<any>([]);

// get artifacts detail
async function fetchData() {
	if (route.params.id) {
		try {
			const response = await useFetchAuth(`/columns/${route.params.id}`) as { columns: any[] };
			columnDetails.value = response || {};
			breadcrumb.value = [
				{ title: 'Catalog', link: '/catalog' },
				{ title: columnDetails.value?.name, link: '#' },
			]
		} catch (error) {
			console.error('Error fetching data:', error);
			columnDetails.value = {};
		}
	}
}

onMounted(() => {
	fetchData();
});

watch(() => route.params.id, () => {
	fetchData();
}, { immediate: true });

console.log(0, route.params.id);


const viewDefault = () => {
	console.log('show default home page');
}

const dummyClick = () => {
	console.log('dummyClick');
}

const navItems = ref<NavItemI[]>([
	{
		label: 'All',
		icon: 'list',
		action: viewDefault
	},
	{
		label: 'Combine Datasets',
		icon: 'chrome',
		action: dummyClick
	},
	{
		label: 'Recently Viewed',
		icon: 'clock',
		action: dummyClick
	},
	{
		label: 'Highlighted',
		icon: 'favourite',
		action: dummyClick
	},
	{
		label: 'Your Catalog',
		icon: 'loading',
		action: dummyClick
	}
]);

const BannerCta = ref<sliderItemI[]>([
	{
		id: 1,
		title: 'Have a question or doubts?',
		text: 'Check our FAQs and Documentation',
		button_text: 'Faqs and Documentation',
		button_link: 'https://www.google.com',
		media_type: 1,
		media_url: slide1,
		template: 1,
	}
])
</script>